;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;
;
;                             GDIptest.asm
;
;    Examples of graphic implementation of gdi+ were posted on the old masm board under
; "GDI Plus - MASM32 implementation", gdiplus_project.rar. (by xzazet March 2004)
; 
;    I have expanded the include file and a correction. [now gdiplus_structures_ver1.inc]
; This program shows examples of loading, scaling and saving image files in all
; supported formats using gdi+

; gdiplus.dll is supplied with windows XP
; gdiplus.dll can be downloaded for win98/2000 from www.microsoft\download

;asmedit V4.7 tested win98
;
;dougiem0305
;dougiem@dougiem.fsnet.co.uk
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

       .486
       .model flat,stdcall
       option casemap:none

       include gdiptest.inc
       include opensave.asm

.code

start:

       include winmain.asm


WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

local ps:PAINTSTRUCT


.if uMsg == WM_CREATE

         invoke InitCommonControls

  ; create global font
         invoke lstrcpy, addr lf.lfFaceName, addr FontName1
         mov lf.lfHeight, -12                    ; Create a font
         mov lf.lfWeight, 400                    ; standard font 1
         invoke CreateFontIndirect, addr lf
         mov hFont1,eax

  ; image window
         invoke CreateWindowEx,0,addr statclass,0,
                   WS_CHILD or WS_VISIBLE or WS_BORDER or SS_BITMAP,
                   20,20,winW,winH,hWin,NULL,hInstance,0
         mov hWimage,eax

  ; top text window
         invoke CreateWindowEx,0,addr statclass,0,
                   WS_CHILD or WS_VISIBLE or SS_CENTER,
                   20,3,winW,14,hWin,NULL,hInstance,0
         mov hWtxt,eax
         invoke SendMessage,hWtxt,WM_SETFONT,hFont1,1

  ; all the buttons
         invoke LoadButtons,hWin

  ; create a background color to use
         invoke GetSysColor,COLOR_BTNFACE
         or eax,0ff000000h   ; high byte = alpha channel
         mov BkGrnd,eax

  ; get display dc (only with GdipCreateFromHDC)
         ;invoke GetDC,hWimage
         ;mov hDC,eax             

  ; init GDI+
         invoke GdiplusStartup,addr hGDIplus,addr GdiPlusSI,0

  ; create a Graphics object to use images with
         invoke GdipCreateFromHWND,hWimage,addr GpGraphics
         ;              or
         ;      invoke GdipCreateFromHDC,hDC,addr GpGraphics

  ; ---------------------------------------------------------------

.elseif uMsg == WM_COMMAND      


; LOAD FILE ;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
  .if wParam == 200                 
         mov szFileName[0],0
         invoke GetFileName,hWin,addr szDisplayName1,addr Imagefilter,hWimage
         jmpif eax,e,0,cncl			;macro

  ; must remove previous image
         jmpif GpImage,e,0,@F
         invoke GdipDisposeImage,GpImage

  ; filename to unitext
     @@: invoke MultiByteToWideChar,CP_ACP,0,addr szFileName,-1,addr utFileName,MAX_PATH*2

  ; get image to use with graphics object
         invoke GdipLoadImageFromFile,addr utFileName,addr GpImage

  ; get width and height
         invoke GdipGetImageWidth,GpImage,addr intW
         invoke GdipGetImageHeight,GpImage,addr intH

  ; setup POSIT structures for image holder(dst) and image(src)
         invoke SetRect,addr src,0,0,intW,intH 
         invoke SetRect,addr dst,0,0,winW,winH 

  ; set a  background col
         invoke GdipGraphicsClear,GpGraphics,BkGrnd

  ; test if image can fully fit in window
         jmpmif intW,a,winW,isfit		;macro
         jmpmif intH,a,winH,isfit

       ;yes 
         invoke AdjustRcToFull,addr dst,addr src,addr fptPcent
         mov Percent,eax
         invoke DrawImageRectsIP,GpGraphics,GpImage,addr dst,addr src
         jmp @F

       ;no
  isfit: invoke AdjustRcToFit,addr dst,addr src,addr fptPcent
         mov Percent,eax
         invoke DrawImageRectsIP,GpGraphics,GpImage,addr dst,addr src
     @@: call ShowPc
         mov hasImage,1
   cncl:


; SAVE FILE ;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
  .elseif wParam == 202         
         jmpif hasImage,e,0,@F
         mov szFileName[0],0
         invoke SaveFileName,hWin,addr szDisplayName2,addr Imagefilter2,hWimage
         jmpif eax,e,0,@F
         mov jpegFlag,0      ; reset jpeg identifier flag

  ; get the extention and make MIME TYPE string (eg "image/bmp"}
         push ebx
         mov eax,offset szFileName
         xor ebx,ebx
         mov bx,ofn.nFileExtension
         add eax,ebx
         invoke wsprintf,addr fType,addr fTypeB,eax
         invoke lcase,addr fType
         mov eax,offset fType
         mov ebx,[eax+6]

       .if ebx == 0067706ah || ebx == 0065706ah || ebx == 6765706ah
         mov ebx,6765706ah   ; traps all jpeg requests, sets jpegFlag and
         mov [eax+6],ebx     ; converts ".jpg" and ".jpe" string requests to
         mov jpegFlag,1      ; "jpeg" string (eg fType-> "image/jpeg")
       .endif
         pop ebx

  ; get the class id GUID for requested format
         invoke GetEncoderClsid,addr fType,addr IClsid
         cmp eax,0          ; test unsupported
         je fok
         invoke MessageBox,hWin,addr szError1,addr szClassName,MB_OK 
         jmp @F

  ; get filename to unitext
    fok: invoke MultiByteToWideChar,CP_ACP,0,addr szFileName,-1,addr utFileName,MAX_PATH*2

       .if jpegFlag == 1     ; save a jpeg with EncoderParameters struc (eps)
         invoke SetQuality,addr eps,addr Quality      ; [0-100]
         invoke GdipSaveImageToFile,GpImage,addr utFileName,addr IClsid,addr eps
         ; error No 7 if file is alredy opened

       .else                 ; all other formats
         invoke GdipSaveImageToFile,GpImage,addr utFileName,addr IClsid,0
         ; error No 7 if file is alredy opened
       .endif

         jmpif eax,ne,7,@F		; cannot write to open file
         invoke MessageBox,hWin,addr szError2,addr szClassName,MB_OK
     @@:

  ; FILL ;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
  .elseif wParam == 204       
         jmpif hasImage,e,0,@F
         invoke SetRect,addr src,0,0,intW,intH 
         invoke SetRect,addr dst,0,0,winW,winH 
         invoke AdjustRcToFill,addr dst,addr src,addr fptPcent
         mov Percent,eax
         call ShowPc
         call ClearWin
         invoke DrawImageRectsIP,GpGraphics,GpImage,addr dst,addr src
     @@:

  ; FIT  ;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
  .elseif wParam == 206       
         jmpif hasImage,e,0,@F
         invoke SetRect,addr src,0,0,intW,intH 
         invoke SetRect,addr dst,0,0,winW,winH 
         invoke AdjustRcToFit,addr dst,addr src,addr fptPcent
         mov Percent,eax
         call ShowPc
         call ClearWin
         invoke DrawImageRectsIP,GpGraphics,GpImage,addr dst,addr src
     @@:

  ; FULL ;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
  .elseif wParam == 208 
         jmpif hasImage,e,0,@F
         invoke SetRect,addr src,0,0,intW,intH 
         invoke SetRect,addr dst,0,0,winW,winH 
         invoke AdjustRcToFull,addr dst,addr src,addr fptPcent
         mov Percent,eax
         call ShowPc
         call ClearWin
         invoke DrawImageRectsIP,GpGraphics,GpImage,addr dst,addr src
     @@:

  ; TEST A ;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
  .elseif wParam == 210 

     mov eax,23
     perr			; macro

  ; 
  ; TEST B ;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
  .elseif wParam == 212 

     mov eax,24
     perrn 42			; macro

     .endif



.elseif uMsg == WM_PAINT
         invoke BeginPaint,hWnd, ADDR ps

     .if hasImage == 1
         invoke DrawImageRectsIP,GpGraphics,GpImage,addr dst,addr src
     .endif

         invoke EndPaint,hWnd, ADDR ps


.elseif uMsg == WM_CLOSE

     .if hGDIplus != 0
         invoke GdipDisposeImage,GpImage
         invoke GdipDeleteGraphics,GpGraphics
         invoke GdiplusShutdown,hGDIplus
     .endif

.elseif uMsg == WM_DESTROY
        invoke PostQuitMessage,NULL
        mov eax,0
        ret
.endif

    		invoke DefWindowProc,hWin,uMsg,wParam,lParam
    ret

WndProc endp


;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
LoadButtons proc hWin:dword

         invoke CreateWindowEx,0,addr ButtClass,addr but1,WS_CHILD or WS_VISIBLE,
                    506,20,68,23,hWin,200,hInstance,0
         invoke SendMessage,eax,WM_SETFONT,hFont1,1
         invoke CreateWindowEx,0,addr ButtClass,addr but2,WS_CHILD or WS_VISIBLE,
                    506,60,68,23,hWin,202,hInstance,0
         invoke SendMessage,eax,WM_SETFONT,hFont1,1
         invoke CreateWindowEx,0,addr ButtClass,addr but3,WS_CHILD or WS_VISIBLE,
                    506,140,68,23,hWin,204,hInstance,0
         invoke SendMessage,eax,WM_SETFONT,hFont1,1
         invoke CreateWindowEx,0,addr ButtClass,addr but4,WS_CHILD or WS_VISIBLE,
                    506,180,68,23,hWin,206,hInstance,0
         invoke SendMessage,eax,WM_SETFONT,hFont1,1
         invoke CreateWindowEx,0,addr ButtClass,addr but5,WS_CHILD or WS_VISIBLE,
                    506,220,68,23,hWin,208,hInstance,0
         invoke SendMessage,eax,WM_SETFONT,hFont1,1
         invoke CreateWindowEx,0,addr ButtClass,addr but6,WS_CHILD or WS_VISIBLE,
                    506,305,68,23,hWin,210,hInstance,0
         invoke SendMessage,eax,WM_SETFONT,hFont1,1
         invoke CreateWindowEx,0,addr ButtClass,addr but7,WS_CHILD or WS_VISIBLE,
                    506,348,68,23,hWin,212,hInstance,0
         invoke SendMessage,eax,WM_SETFONT,hFont1,1
     ret
LoadButtons endp

;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
ShowPc proc uses ebx
              ; dispays the name, size and pecent
         mov eax,offset szFileName
         movzx ebx,ofn.nFileOffset
         add eax,ebx
         invoke wsprintf,addr pctxt,addr pctxtB,eax,intW,intH,Percent
         invoke SetWindowText,hWtxt,addr pctxt
     ret
ShowPc endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
ClearWin proc
         push ebx       ; sets a background only
         mov ebx,dst.h  ; if this image is smaller than last
         mov eax,dst.w
     .if eax < lastW || ebx < lastH
         invoke GdipGraphicsClear,GpGraphics,BkGrnd
     .endif
         mov eax,dst.w
         jmpif eax,b,winW,@F
         mov eax,winW
     @@: mov lastW,eax
         mov eax,dst.h
         jmpif eax,b,winH,@F
         mov eax,winH
     @@: mov lastH,eax
         pop ebx
     ret
ClearWin endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
end start








;;;;;