; OpenSave.asm
; part of GDIptest.asm
;dougiem0305
;dougiem@dougiem.fsnet.co.uk

; information:: "Explorer-Style Hook Procedures" from Win32 Help


    GetFileName  PROTO :DWORD, :DWORD, :DWORD, :DWORD
    SaveFileName PROTO :DWORD, :DWORD, :DWORD, :DWORD

	  ofnHookA     PROTO :DWORD, :DWORD, :DWORD, :DWORD
	  ofnHookB     PROTO :DWORD, :DWORD, :DWORD, :DWORD

	  .const
	; values for openfilename dialogs
		CDN_FIRST		equ 0-601
		CDN_LAST			equ 0-699
		CDN_INITDONE		equ CDN_FIRST
		CDN_SELCHANGE		equ CDN_FIRST-1
		CDN_FOLDERCHANGE	equ CDN_FIRST-2
		CDN_SHAREVIOLATION equ CDN_FIRST-3
		CDN_HELP			equ CDN_FIRST-4
		CDN_FILEOK		equ CDN_FIRST-5
		CDN_TYPECHANGE	equ CDN_FIRST-6

	; dlg in rc file
		IDD_PREVIEW		equ 3000
		IDD_JPEG			equ 2000
		IDC_STATIC01		equ 2001
		IDC_STATIC02		equ 2002
		IDC_TRACK01		equ 2003
		IDC_CHK01		equ 2004

	; these are the constants used for the windows
	; filename dialog box. you can retrieve the handle
  ; using GetParent and then GetDlgItem
		stc2 			equ 441h		; static 2
		psh1 			equ 400h		; button 1
		lst2 			equ 461h		; parent of listview32
		edt1 			equ 480h		; file input edit box
		cmb1 			equ 470h		; combo 1
		cmb2 			equ 471h		; combo 2
; edt1 is the filename text input box used here

	  .data?
	  OFNOTIFY struct 
  		hdr       NMHDR <>
  		lpofn     dword 0 
  		lpstr     dword 0
	  OFNOTIFY ends

    .data
      	szFileName 		db 260 dup(0)
			chktxt			db "on",0

      	ofn        		OPENFILENAME <>  ; structure
			Edbuffer		db 80 DUP (0)
			uEdbuffer		db 160 DUP (0)

			sDlg			dd 0	; dialog handle
			custD			dd 0 ; hWimage, from custom patameter
			hEd			dd 0

; gdi+ objects, sizes and structs
			GpvGraphics 	dd 0
			GpvImage    	dd 0
     	vdst        	POSIT <>
     	vsrc        	POSIT <>
			pvW			dd 0
			pvH			dd 0

; text converts
			iquality       	db 80 DUP (0)
			iqualityB      	db "Jpeg Quality: %lu%%",0
			isize		   	db 80 DUP (0)
			isizeB		   	db "Image Size = %lu x %lu",0dh,0ah,0ah,"File Size: %lu k",0

; handles
 			hWpv			dd 0 ; preview win
			hTrk1          	dd 0
			hTxt1          	dd 0
			hChk1			dd 0

; flags
			chkState		dd 1


    .code

; ########################################################################

GetFileName proc hParent:DWORD,lpTitle:DWORD,lpFilter:DWORD,custInfo:DWORD

	; Uses a resource template and a hook proc. 
  ; Resizes/positions dlg window and draws a
	; thumbnail size image

    mov ofn.lStructSize,        sizeof OPENFILENAME
    m2m ofn.lCustData,          custInfo
    m2m ofn.hWndOwner,          hParent
    m2m ofn.hInstance,          hInstance
    m2m ofn.lpstrFilter,        lpFilter
    m2m ofn.lpstrFile,          offset szFileName
    mov ofn.nMaxFile,           sizeof szFileName
    m2m ofn.lpstrTitle,         lpTitle
    m2m ofn.lpfnHook,		   offset ofnHookA
    mov ofn.Flags,OFN_EXPLORER or OFN_HIDEREADONLY or OFN_ENABLEHOOK or 00800000h\ ;resize
										or OFN_ENABLETEMPLATE or OFN_FILEMUSTEXIST
	  mov ofn.lpTemplateName,	   IDD_PREVIEW
    invoke GetOpenFileName,ADDR ofn
	  push eax
    invoke GdipDeleteGraphics,GpvGraphics
	  pop eax
    ret

GetFileName endp

; #########################################################################

SaveFileName proc hParent:DWORD,lpTitle:DWORD,lpFilter:DWORD,custInfo:DWORD

	; uses a resource template and a hook proc
	; hook is for the trackbar control for jpeg quality

    mov ofn.lStructSize,        sizeof OPENFILENAME
    m2m ofn.lCustData,          custInfo
    m2m ofn.hWndOwner,          hParent
    m2m ofn.hInstance,          hInstance
    m2m ofn.lpstrFilter,        lpFilter
    m2m ofn.lpstrFile,          offset szFileName
    mov ofn.nMaxFile,           sizeof szFileName
    m2m ofn.lpstrTitle,         lpTitle
    mov ofn.Flags,OFN_EXPLORER or OFN_HIDEREADONLY\
					or 00800000h or OFN_ENABLETEMPLATE  or OFN_ENABLEHOOK

; gdi+ will not overwrite an open file. (ie you cannot replace existing)
; An error 7 trap is in winproc

	  mov ofn.lpTemplateName,     IDD_JPEG
    m2m ofn.lpfnHook,		   offset ofnHookB        
    invoke GetSaveFileName,ADDR ofn

    ret

SaveFileName endp

;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;
; THE OPEN FILE CALLBACK
ofnHookA Proc uses edi esi ecx hdlg:dword,uiMsg:dword,wParam:dword,lParam:dword
	local rc:RECT
	local fno:OFNOTIFY

; I tried using the THUMBNAIL functions but they were just as slow
; on large bmps and gave no scale.

	.if uiMsg == WM_COMMAND

		.if wParam == IDC_CHK01		; adjust the chkState variable
			  invoke SendMessage,hChk1,BM_GETCHECK,0,0
			.if eax == 1
				mov chkState,1
				mov fno.hdr.code,CDN_SELCHANGE
				invoke SendMessage,hdlg,WM_NOTIFY,IDC_CHK01,0
			.else
				mov chkState,0
				invoke GdipGraphicsClear,GpvGraphics,BkGrnd
			.endif
				invoke SetFocus,hWpv	; remove focus
		.endif

	.elseif uiMsg == WM_PAINT

  			call ShowPreview
				mov eax,0
				ret

	.elseif uiMsg == WM_NOTIFY		; sent from dlg with lParam -> to a OFNOTIFY struc

				jmpif wParam,ne,IDC_CHK01,@F		; macro
				mov eax,CDN_SELCHANGE	; if checkbox, modify code No to  CDN_SELCHANGE
				jmp xend				; so image is updated on check

		@@: mov esi,lParam			
				lea edi,fno
				mov ecx,sizeof OFNOTIFY	; copy the notify structure
				rep movsb

				mov eax,fno.lpofn		; get ofn structure
				add eax,64			
				mov eax,[eax]			; point to custom data - the handle of image window
				mov custD,eax	
				mov eax,fno.hdr.code	; get the CDN_ code number
		 xend:

 		.if eax == CDN_INITDONE		; here once - after the dialog has init
				invoke GetParent,hdlg
				mov sDlg,eax
				invoke GetWindowRect,custD,addr rc
				mov eax,rc.left		; adjust dlg box to
				Sub rc.right,eax		; same size/pos as image window
				mov eax,rc.top
				Sub rc.bottom,eax

     	; resize dialog window
				invoke SetWindowPos,sDlg,0,rc.left,rc.top,rc.right,rc.bottom,0

			; get the filename input edit box handle
				invoke GetDlgItem,sDlg,edt1
				mov hEd,eax

			; get dialog control windows from IDD_PREVIEW
				invoke GetDlgItem,hdlg,IDC_STATIC02
				mov hWpv,eax
				invoke GetDlgItem,hdlg,IDC_CHK01
				mov hChk1,eax
				invoke GetDlgItem,hdlg,IDC_STATIC01
				mov hTxt1,eax
				jmpif chkState,e,0,@F
				invoke SendMessage,hChk1,BM_SETCHECK,1,0

			; get graphics object
		@@:	invoke GdipCreateFromHWND,hWpv,addr GpvGraphics
				invoke GdipGraphicsClear,GpvGraphics,BkGrnd


		.elseif eax == CDN_SELCHANGE
				invoke LoadCursor,0,32514	; hourglass cursor	
        	invoke SetCursor,eax

  			call ShowPreview			; output image
				jmpif eax,e,0,xout			; returnd 0 if no text in edit box

		  	push ebx
				invoke filesize,addr Edbuffer ; get file size
				mov ebx,1024				; set text image size.
				xor edx,edx				; size to k bytes
				div ebx
				invoke wsprintf,addr isize,addr isizeB,pvW,pvH,eax
				invoke SetWindowText,hTxt1,addr isize
				pop ebx					
	 xout:

		.elseif eax == CDN_FOLDERCHANGE
				; this stops CDN_SELCHANGE from looking for a new image 
				; when folder change sends CDN_SELCHANGE

				invoke SetWindowText,hEd,0
				invoke GdipGraphicsClear,GpvGraphics,BkGrnd
				invoke SetWindowText,hTxt1,0

		.endif

	.endif
		ret
ofnHookA endp



;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
ShowPreview proc
	   		invoke GetDlgItem,sDlg,edt1	; test for text in window
				invoke SendMessage,eax,WM_GETTEXT,80,addr Edbuffer
				jmpif eax,e,0,xover

			; here we check the check box and skip draw image
				mov eax,1
				jmpif chkState,e,0,xover

         invoke MultiByteToWideChar,CP_ACP,0,addr Edbuffer,-1,addr uEdbuffer,160
         invoke GdipLoadImageFromFile,addr uEdbuffer,addr GpvImage
				jmpif eax,e,0,@F
			
			; detects a wrong filename comming to preview
				invoke GdipGraphicsClear,GpvGraphics,BkGrnd
				invoke SetWindowText,hTxt1,0
				mov eax,0
				jmp xover
										; 'fill/fit' preview win (same as in winproc)
		@@: invoke GdipGraphicsClear,GpvGraphics,BkGrnd
         invoke GdipGetImageWidth,GpvImage,addr pvW
         invoke GdipGetImageHeight,GpvImage,addr pvH
         invoke SetRect,addr vsrc,0,0,pvW,pvH 
         invoke SetRect,addr vdst,0,0,90,70
				invoke AdjustRcToFit,addr vdst,addr vsrc,0
;					try this instead
				;invoke AdjustRcToFill,addr vdst,addr vsrc,0
         invoke DrawImageRectsIP,GpvGraphics,GpvImage,addr vdst,addr vsrc
			; must dispose
         invoke GdipDisposeImage,GpvImage
				mov eax,1
	xover: ret

ShowPreview endp



;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
; THE SAVE FILE CALLBACK
ofnHookB Proc uses edi esi ecx hdlg:dword,uiMsg:dword,wParam:dword,lParam:dword
	local rc:RECT
	local fno:OFNOTIFY

; The Open ofnHookA has already set window size
; all to do here is update Quality dword from trackbar

	.if uiMsg == WM_INITDIALOG
				invoke GetParent,hdlg
				mov sDlg,eax
         invoke  GetDlgItem,hdlg,IDC_TRACK01
         mov hTrk1,eax
         invoke  GetDlgItem,hdlg,IDC_STATIC01
         mov hTxt1,eax				; range 5 - 100
   			invoke SendMessage,hTrk1,TBM_SETRANGE,1,0640005h
				invoke SendMessage,hTrk1,TBM_SETTICFREQ,2,1
				invoke SendMessage,hTrk1,TBM_SETPAGESIZE,0,1
				invoke SendMessage,hTrk1,TBM_SETPOS,1,Quality
				invoke wsprintf,addr iquality,addr iqualityB,Quality
				invoke SetWindowText,hTxt1,addr iquality
				mov eax,Quality
				shl eax,1
				add eax,22	; size relative to extention of dlg
				invoke SetWindowPos,hTxt1,0,eax,6,0,0,SWP_NOSIZE

	.elseif uiMsg == WM_HSCROLL

         mov eax,wParam
         and eax,0ffffh
   	.if eax == TB_THUMBTRACK || TB_PAGEUP || TB_PAGEDOWN
				invoke GetDlgItem,sDlg,edt1	; take focus off
				invoke SetFocus,eax
         mov eax,lParam
       .if eax == hTrk1				; QUALITY set
			; get quality
				invoke SendMessage,hTrk1,TBM_GETPOS,0,0
				mov Quality,eax
				shl eax,1
				add eax,22	; size relative to full dlg
				invoke SetWindowPos,hTxt1,0,eax,245,0,0,SWP_NOSIZE
			; and print it
				invoke wsprintf,addr iquality,addr iqualityB,Quality
				invoke SetWindowText,hTxt1,addr iquality
			.endif
		.endif
	.endif
		ret
ofnHookB endp
;
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


;
