;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

;							GDIpfunctions.asm


; gdiplus.dll:: microsoft.com\downloads

; information:: gdi+ c++ documentation from: http://www.progdigy.com/gdiplus/


;dougiem0305
;dougiem@dougiem.fsnet.co.uk
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


       ;include 	 gdipFiles\gdiplus_V0a.inc
       ;includelib  gdipFiles\gdiplus.lib
       ;include 	 gdipFiles\gdiplus_structures_ver1.inc


     ; gdipfunctions 
        GetEncoderClsid     proto :dword,:dword
        largestRatio        proto :dword,:dword,:dword,:dword,:dword
        AdjustRcToFit       proto :dword,:dword,:dword
        AdjustRcToFill      proto :dword,:dword,:dword
        AdjustRcToFull      proto :dword,:dword,:dword
        DrawImageRectsIP    proto :dword,:dword,:dword,:dword
        GetRawFormat        proto :dword,:dword,:dword

     ; debug
        perror              proto :dword,:dword
        perrorn             proto :dword,:dword,:dword
        StringFromGUID      proto :dword,:dword



;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

;    MACROS 

; assumes main window hWnd: displays error code
perr macro
       invoke perror,hWnd,eax
     endm


; assumes main window hWnd: displays error code and user position
perrn macro arg1
       invoke perrorn,hWnd,eax,arg1
     endm


; EXAMPLE - jmpif eax,NE,ebx,location
; same as -   cmp eax,ebx
;             jne location
     jmpif macro val1,val2,val3,val4
       cmp val1,val3
       j&val2& val4
     endm


; Copies a GUID struc forom arg2 to arg1
     movGUID macro arg1,arg2
       push edi
       push esi
       push ecx
       mov ecx,4
       mov edi,arg1
       mov esi,arg2
       rep movsd
       pop ecx
       pop esi
       pop edi
     endm


; Compares addrGUID arg2 with addrGUID arg1 (eax=0=match)
     cmpGUID macro arg1,arg2
       push edi
       push esi
       push ecx
       mov ecx,17
       mov edi,arg1
       mov esi,arg2
       repe cmpsb
       mov eax,ecx
       pop ecx
       pop esi
       pop edi
     endm

;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


.data?

       POSIT struct
         x  dword ?
         y  dword ?
         w  dword ?
         h  dword ?
       POSIT ends

.const

       FP_LESSTHAN           equ 01h
       FP_EQUALTO            equ 40h

       MAX_FORMATS           equ 11    ; reflects number of supported formats

;status codes
       Ok                    equ 0
       GenericError          equ 1
       InvalidParameter      equ 2
       OutOfMemory           equ 3
       ObjectBusy            equ 4
       InsufficientBuffer    equ 5
       NotImplemented        equ 6
       Win32Error            equ 7
       WrongState            equ 8
       Aborted               equ 9
       FileNotFound          equ 10
       ValueOverflow         equ 11
       AccessDenied          equ 12
       UnknownImageFormat    equ 13
       FontFamilyNotFound    equ 14
       FontStyleNotFound     equ 15
       NotTrueTypeFont       equ 16
       UnsupportedGdiplusVersion equ 17
       GdiplusNotInitialized equ 18
       PropertyNotFound      equ 19
       PropertyNotSupported  equ 20
;my additions
       EncoderClsidNotFound  equ 21
       AbsoluteNearlyOkB     equ 22
.data

     ; save formats GDI+ supports (GetEncoderClsid)
       iBmp                  db "image/bmp",0
       iGif                  db "image/gif",0
       iJpeg                 db "image/jpeg",0
       iPng                  db "image/png",0
       iTiff                 db "image/tiff",0

     ; these save formats not included in GDI+
       ;iEmf                 db "image/emf",0
       ;iExif                db "image/exif",0
       ;iWmf                 db "image/wmf",0
       ;iIcon                db "image/icon",0

     ; error code output strings
       ercaptionF            db "GDI+ - Error Number %lu ",0
       capF                  db "Description:- %hs",0
       capFn                 db "Description:-  %hs",0dh,0ah,"From position number: %lu",0
       cap                   db 80 DUP (0)
       ercaption             db 80 DUP (0)

       pc100                 real4 1.0

Codes  db "Undefined Error Number",0   
       db "GenericError",0             ; 1
       db "InvalidParameter",0
       db "OutOfMemory",0
       db "ObjectBusy",0
       db "InsufficientBuffer",0
       db "NotImplemented",0
       db "Win32Error",0
       db "WrongState",0
       db "Aborted",0
       db "FileNotFound",0             ; 10
       db "ValueOverflow",0
       db "AccessDenied",0
       db "UnknownImageFormat",0
       db "FontFamilyNotFound",0
       db "FontStyleNotFound",0
       db "NotTrueTypeFont",0
       db "UnsupportedGdiplusVersion",0
       db "GdiplusNotInitialized",0
       db "PropertyNotFound",0
       db "PropertyNotSupported",0     ; 20
; additions
       db "Encoder Class id not found",0
       db "GUID not found within format range",0 ; 22
       db "create new error codes",0
       db "Absolutly Nearly ok",0,0         ; final string must have 0,0






;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;
; GetEncoderClsid , addr mtype, addr GUID
;
GetEncoderClsid proto :dword,:dword
;
;
;  The function receives addr of a MIME type string, ('mtype')of an encoder, and returns
; the class identifier (CLSID) of that encoder. 
;  The MIME types of the encoders built into GDI+ are as follows: 
;         "image/bmp",0 "image/jpeg",0 "image/gif",0 "image/tiff",0 "image/png",0.
;  The function first calls GdipGetImageEncodersSize to get the number supported and the
; total size of all the structures, and then calls GdipGetImageEncoders to get 
; the array of all ImageCodecInfo objects. 
;  If the ptr ImageCodecInfo.MimeType of any object in that array matches the requested encoder 'mtype', 
; the function returns 0 and copies the CLSID into the GUID pointed to by 'clsid'. 
; If the function fails to match a codec, it returns error code 23.
;dougiem0305

.code

GetEncoderClsid proc uses esi edi ecx mtype:dword,clsid:dword
  local ansiTxt [40]:byte
  local ptrUtxt     :dword
  local Array       :dword
  local ptrArray    :dword
  local cnum        :dword
  local csize       :dword
  local offMimeType :dword

         mov offMimeType,48  ; offset into ImageCodecInfo STRUC for mime str addr

         invoke GdipGetImageEncodersSize,addr cnum,addr csize   

         jmpif cnum,e,0,error
         invoke GlobalAlloc,GPTR,csize
         jmpif eax,e,0,error
         mov Array,eax
         mov ptrArray,eax    ; start of array of all ImageCodecInfo structures

         invoke GdipGetImageEncoders,cnum,csize,Array ; load all strucs

     @@: mov eax,ptrArray
         add eax,offMimeType
         mov eax,[eax]
         mov ptrUtxt,eax     ; pointer to unitext Type string in array

         invoke WideCharToMultiByte,CP_ACP,0,ptrUtxt,-1,addr ansiTxt,40,0,0
         invoke lstrcmp,addr ansiTxt,mtype ;convert and compare

         jmpif eax,e,0,@F    ; if string NOT match to input string
         add ptrArray,sizeof ImageCodecInfo
         dec cnum            ; then add a structure length
         jne @B              ; and do more

         invoke GlobalFree,Array
         jmp error           ; no match

     @@: mov edi,clsid       ; else copy the ClassID GUID
         mov esi,ptrArray    ; to caller
         mov ecx,4
         rep movsd
         invoke GlobalFree,Array
         mov eax,0
       ret

error: mov eax,21
       ret

GetEncoderClsid endp




;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;
;      DrawImageRectsIP, addr rcDesination, addrrcSource
;
DrawImageRectsIP    proto :dword,:dword,:dword,:dword
;
;
; Draws the image using two rectangls, destination area (the placeholder for image)
; and source area (the image size). The units are Integers and the format units are Pixels
; returns 0 = ok else gdi+ error code
;dougiem0305

.code

DrawImageRectsIP proc uses ecx graph:dword,image:dword,dest:dword,source:dword

         mov eax,source
         mov ecx,dest

invoke GdipDrawImageRectRectI,graph,image,[ecx],[ecx+4],[ecx+8],[ecx+12],
                             [eax],[eax+4],[eax+8],[eax+12],UnitPixel,0,0,0
         ret

DrawImageRectsIP endp





;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;
; GetRawFormat, gpImage, addr GUID
;
;
GetRawFormat proto :dword,:dword,:dword
;
.const
MAX_FORMATS  equ 11

;
; The function GetRawFormat gets a globally unique identifier (GUID) that identifies 
; the format of the 'image' object. This GUID is then copied to pointer 'guid'.
;  In addition, GUIDs that identify various file formats are stored in the .data section.
; These format locations, are compared to the GUID obtained from the image
;  Locations should be kept together and the constant MAX_FORMATS set to
; the number of format GUIDS present.
;  The function will fill ptr 'gnum' [if not NULL] with  a zero based number 
; representing the the position of the GUID (within .data) which matches the requested.
; eg: [gnum] = 2 = ImageFormatBMP. 
; returns 0 = ok
; error returns error code 22
;
;    (note: a loaded image called "abcdef.bmp" could, in fact be any format - gdi+ will load it) 
;
;dougiem0305

.code

GetRawFormat proc uses edi esi ecx image:dword,guid:dword,gnum:dword

         invoke GdipGetImageRawFormat,image,guid
         jmpif eax,ne,0,errorb
         mov esi,guid
         mov edi,offset ImageFormatUndefined
         mov ecx,0
     @@: cmpGUID edi,esi
         jmpif eax,e,0,@F
         add edi,16
         inc ecx
         jmpif ecx,a,MAX_FORMATS,errora
         jmp @B
         
     @@: mov eax,gnum
         jmpif eax,e,0,@F
         mov [eax],ecx
     @@: mov eax,0
         ret
 errora: mov eax,22
 errorb: ret

GetRawFormat endp






;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;
;    SetQuality, addr EncoderParameters, addr intQuality
;
SetQuality    proto :dword,:dword
;
;
; This function sets the quality for JPEG image recording.
;  A ptr to an EncoderParameters structue is received in 'pStruc' and
; a ptr to the Quality integer [0 - 100] is in pQual
;  A local struture is filled with the gEncoderQuality GUID (from .data) and
; and the Quality integer and copied to ptr pStruc. pStruc should then
; be used as the 4th param in function GdipSaveImageToFile (for JPEG).
; return maintains all registers
;dougiem0305

.code

SetQuality proc uses edi esi ecx eax pStruc:dword,pQual:dword
  local eStruc:EncoderParameters

         mov eStruc.Count,1
         lea eax,eStruc.Parameter.pGUID
         movGUID eax,offset gEncoderQuality
         mov eStruc.Parameter.vType,EncoderParameterValueTypeLong
         mov eStruc.Parameter.NumberOfValues,1
         mov eax,pQual
         mov eStruc.Parameter.value,eax
         mov ecx,sizeof EncoderParameters
         lea esi,eStruc
         mov edi,pStruc
         rep movsb

     ret
SetQuality endp







;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;
;      AdjustRcToFit

AdjustRcToFit      proto :dword,:dword,:dword
;
;
; This routine will adjust the the dest (image holder) to
; make the image best FIT in the window while keeping its scale.
;  Entry: destination < > set to display size, source < > set to image size.
; Loads a real4 pointer (if not NULL), fpt, with scale factor [150% = 1.5]
; returns integer pecentage change from original
;dougiem0305

.code

AdjustRcToFit proc uses ebx dest:dword,source:dword,fpt:dword
  local sRc  :POSIT
  local dRc  :POSIT
  local flp  :real4
  local fpc  :real4
  local percent:dword

         lea eax,dRc       ; copy destination sizes
         invoke CopyRect,eax,dest
         lea eax,sRc       ; and source sizes
         invoke CopyRect,eax,source

     ; the largest raitio is required to determine wether the width or
     ; the height is the maxim
         invoke largestRatio,sRc.w,sRc.h,dRc.w,dRc.h,addr flp

         jmpif eax,e,0,@F

         mov ebx,dRc.w       ; save original destW
         finit
         fild dRc.h          ; (destH/sourceH)*sourceW = new destW
         fild sRc.h
         fdiv
         lea eax,fpc
         fst real4 ptr [eax]
         fimul sRc.w
         lea eax,dRc.w
         fistp dword ptr [eax]

         sub ebx,dRc.w
         shr ebx,1           ; calculate the x position
         mov dRc.x,ebx
         jmp xout

     @@: mov ebx,dRc.h
         finit
         fild dRc.w          ; (destW/sourceW)*sourceH = new destH
         fild sRc.w
         fdiv
         lea eax,fpc
         fst real4 ptr [eax]
         fimul sRc.h
         lea eax,dRc.h
         fistp dword ptr [eax]

         sub ebx,dRc.h
         shr ebx,1
         mov dRc.y,ebx

   xout: lea eax,dRc       ; only destination sizes changed
         invoke CopyRect,dest,eax

         mov eax,fpt
         jmpif eax,e,0,@F
         mov ebx,fpc
         mov [eax],ebx
         mov dword ptr [eax],ebx
     @@: mov percent,100
         fild percent
         lea eax,fpc
         fld real4 ptr [eax]
         fmul
         lea eax,percent
         fistp dword ptr [eax]
         mov eax,[eax]
     ret

AdjustRcToFit endp






;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;
;      AdjustRcToFill
;
AdjustRcToFill          proto :dword,:dword,:dword
;
;
; This routine will adjust the dest (image holder) to make the image FILL the window, 
; centered, while keeping its scale. Sized to width or height, depending on the greater ratio.
;  Entry: destination < > set to display size, source < > set to image size.
; Loads a real4 pointer (if not NULL), fpt, with scale factor [eg: 150% = 1.5]
; returns integer pecentage change from original
;dougiem0305

.code

AdjustRcToFill proc uses ebx dest:dword,source:dword,fpt:dword
  local sRc  :POSIT
  local dRc  :POSIT
  local flp  :real4
  local fpc  :real4
  local percent:dword

         lea eax,sRc       ; source size
         invoke CopyRect,eax,source
         lea eax,dRc       ; and destination size
         invoke CopyRect,eax,dest

     ; the largest raitio is required to determine wether the width or
     ; the height is the maxim
         invoke largestRatio,sRc.w,sRc.h,dRc.w,dRc.h,addr flp
         jmpif eax,e,0,@F

         mov ebx,dRc.h
         finit
         fild dRc.w          ; (destW/sourceW)*sourceH = new destH
         fild sRc.w
         fdiv
         lea eax,fpc
         fst real4 ptr [eax]
         fimul sRc.h
         lea eax,dRc.h
         fistp dword ptr [eax]

         mov eax,[eax]
         sub eax,ebx         ; destination height is larger than the
         shr eax,1           ; window so a negative offset
         neg eax             ; for the y position
         mov dRc.y,eax
         jmp xout


     @@: mov ebx,dRc.w  
         finit
         fild dRc.h          ; (destH/sourceH)*sourceW = new destW
         fild sRc.h
         fdiv
         lea eax,fpc
         fst real4 ptr [eax]
         fimul sRc.w
         lea eax,dRc.w
         fistp dword ptr [eax]

         mov eax,[eax]
         sub eax,ebx
         shr eax,1 
         neg eax
         mov dRc.x,eax

   xout: lea eax,dRc       ; only destination sizes changed
         invoke CopyRect,dest,eax

         mov eax,fpt
         jmpif eax,e,0,@F
         mov ebx,fpc
         mov [eax],ebx
         mov dword ptr [eax],ebx
     @@: mov percent,100
         fild percent
         lea eax,fpc
         fld real4 ptr [eax]
         fmul
         lea eax,percent
         fistp dword ptr [eax]
         mov eax,[eax]
     ret

AdjustRcToFill endp








;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;
;      AdjustRcToFull
;
AdjustRcToFull          proto :dword,:dword,:dword
;
;
;
; This routine will adjust the source(image) sizes to the dest(image holder) to
; current FULL size, centered. [sRc is what is visible]
;  Entry: destination < > set to display size, source < > set to image size.
; Loads a real4 pointer (if not NULL), fpt, with scale factor 1.0
; returns integer pecentage 100
;dougiem0305

.code

AdjustRcToFull proc uses ebx dest:dword,source:dword,fpt:dword
  local sRc  :POSIT
  local dRc  :POSIT
  local percent:dword
         lea eax,dRc       ; cop destination size
         invoke CopyRect,eax,dest
         lea eax,sRc       ; and source size
         invoke CopyRect,eax,source
; x
         mov eax,dRc.w
         mov ebx,sRc.w
         jmpif ebx,a,eax,@F
         push sRc.w
         pop dRc.w
         sub eax,ebx
         shr eax,1
         mov dRc.x,eax
         jmp gety

     @@: sub ebx,eax
         sub sRc.w,ebx
         shr ebx,1
         mov sRc.x,ebx
; y
   gety: mov eax,dRc.h
         mov ebx,sRc.h
         jmpif ebx,a,eax,@F
         push sRc.h
         pop dRc.h
         sub eax,ebx
         shr eax,1
         mov dRc.y,eax
         jmp xout

     @@: sub ebx,eax
         sub sRc.h,ebx
         shr ebx,1
         mov sRc.y,ebx

   xout: lea eax,sRc       ; copy back source size
         invoke CopyRect,source,eax
         lea eax,dRc       ; and destination size
         invoke CopyRect,dest,eax

         mov eax,fpt
         jmpif eax,e,0,@F
         mov ebx,pc100
         mov dword ptr [eax],ebx
     @@: mov eax,100
     ret
AdjustRcToFull endp






;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

largestRatio      proto :dword,:dword,:dword,:dword,:dword

; Determinds which rect, has the largest ratio
; if product (w2/h2) < (w1/h1) returns 1  and (w1/h1)->lprod [real4]
; else                         returns 0  and (w2/h2)->lprod

.code

largestRatio proc uses ebx w1:dword,h1:dword,w2:dword,h2:dword,lprod:dword
  local prod1 :real4
  local prod2 :real4

     finit
     fild    w2
     fild    h2
     fdiv
     lea eax,prod1
     fstp real4 ptr [eax]
     finit
     fild    w1
     fild    h1
     fdiv
     lea eax,prod2
     fst real4 ptr [eax]
     lea eax,prod1
     FCOMP real4 ptr [eax]
     fstsw ax
  .IF (ah & FP_LESSTHAN)
     mov eax,lprod 
     mov ebx,prod1
     mov [eax],ebx
     mov eax,1
  .else
     mov eax,lprod 
     mov ebx,prod2
     mov [eax],ebx
     mov eax,0
  .endif

     ret
largestRatio endp







;                            DEBUG ROUTINES

;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;
;    StringFromGUID     ASCII string FROM GUID
;
StringFromGUID     proto :dword,:dword
;
;
; This function converts a GUID pointed to by 'guid' into an ascii string and places
; it in a buffer pointed to by 'ansi'. The buffer 'ansi' should be a minimum of 
; 33 bytes in size.
; returns a pointer to the ansi string
;dougiem0305

.code

StringFromGUID proc uses edi esi ecx ansi:dword,guid:dword
         mov edi,ansi
         mov esi,guid
         mov eax,[esi]
         mov ecx,16

     .while ecx !=0
         mov al,[esi]
         mov ah,al
         shr al,4
         or al,30h
         jmpif al,b,3ah,@F
         add al,7
     @@: mov [edi],al
         and ah,0fh
         or ah,30h
         jmpif ah,b,3ah,@F
         add ah,7
     @@: mov [edi+1],ah
         inc esi
         add edi,2
         dec ecx
     .endw
         mov byte ptr [edi],0
         mov eax,ansi
     ret
StringFromGUID endp







;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;
; perror      ERROR CODE
;
perror proto :dword,:dword
;
;
; The function assumes codeno is a status number returned by a Gdip function.
; It prints the error string associated with the number on a messagebox.
; Used by "MACRO perr"
; return maintains all registers
;dougiem 0305

.code

perror proc hWin:dword,codeno:dword
local estr :dword

         pushad
         mov eax,codeno
         jmpif eax,le,0,xit
         mov ah,al
         mov edi,offset Codes
         mov al,0
   more: mov ecx,0ffh
         repne scasb
         cmp byte ptr [edi],0
         jne @F
         mov edi,offset Codes
         mov estr,edi
         jmp xout
     @@: dec ah
         jne more
         mov estr,edi
   xout: mov eax, codeno
         invoke wsprintf,addr ercaption,addr ercaptionF,eax
         invoke wsprintf,addr cap,addr capF,estr
         invoke MessageBox,hWin,addr cap,addr ercaption,MB_OK
    xit: popad     
         ret

perror endp






;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;
; perrorn     ERROR CODE with SOURCE LOCATION
;
perrorn proto :dword,:dword,:dword
;
;
; The function assumes codeno is a status number returned by a Gdip function,
; and posit is a user defined integer.
; It prints the error string associated with the codeno number and the  posit number
; on a messagebox.
; Used by "MACRO perrn "
; return maintains all registers
;dougiem 0305

perrorn proc hWin:dword,codeno:dword,posit:dword
local estr :dword

         pushad
         mov eax,codeno
         jmpif eax,le,0,xit
         mov ah,al
         mov edi,offset Codes
         mov al,0
   more: mov ecx,0ffh
         repne scasb
         cmp byte ptr [edi],0
         jne @F
         mov edi,offset Codes
         mov estr,edi
         jmp xout
     @@: dec ah
         jne more
         mov estr,edi
   xout: mov eax, codeno
         invoke wsprintf,addr ercaption,addr ercaptionF,eax
         invoke wsprintf,addr cap,addr capFn,estr,posit
         invoke MessageBox,hWin,addr cap,addr ercaption,MB_OK
    xit: popad     
         ret
perrorn endp

;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


;